SFML

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes | List of all members
sf::Sound Class Reference
Audio module

Regular sound that can be played in the audio environment. More...

`#include <Sound.hpp>`

Inheritance diagram for sf::Sound:

## Public Types
enum | Status { Stopped, Paused, Playing }
| Enumeration of the sound source states. More...

## Public Member Functions
| Sound ()
| Default constructor. More...
| Sound (const SoundBuffer &buffer)
| Construct the sound with a buffer. More...
| Sound (const Sound &copy)
| Copy constructor. More...
| ~Sound ()
| Destructor. More...
void | play ()
| Start or resume playing the sound. More...
void | pause ()
| Pause the sound. More...
void | stop ()
| stop playing the sound More...
void | setBuffer (const SoundBuffer &buffer)
| Set the source buffer containing the audio data to play. More...
void | setLoop (bool loop)
| Set whether or not the sound should loop after reaching the end. More...
void | setPlayingOffset (Time timeOffset)
| Change the current playing position of the sound. More...
const SoundBuffer * | getBuffer () const
| Get the audio buffer attached to the sound. More...
bool | getLoop () const
| Tell whether or not the sound is in loop mode. More...
Time | getPlayingOffset () const
| Get the current playing position of the sound. More...
Status | getStatus () const
| Get the current status of the sound (stopped, paused, playing) More...
Sound & | operator= (const Sound &right)
| Overload of assignment operator. More...
void | resetBuffer ()
| Reset the internal buffer of the sound. More...
void | setPitch (float pitch)
| Set the pitch of the sound. More...
void | setVolume (float volume)
| Set the volume of the sound. More...
void | setPosition (float x, float y, float z)
| Set the 3D position of the sound in the audio scene. More...
void | setPosition (const Vector3f &position)
| Set the 3D position of the sound in the audio scene. More...
void | setRelativeToListener (bool relative)
| Make the sound's position relative to the listener or absolute. More...
void | setMinDistance (float distance)
| Set the minimum distance of the sound. More...
void | setAttenuation (float attenuation)
| Set the attenuation factor of the sound. More...
float | getPitch () const
| Get the pitch of the sound. More...
float | getVolume () const
| Get the volume of the sound. More...
Vector3f | getPosition () const
| Get the 3D position of the sound in the audio scene. More...
bool | isRelativeToListener () const
| Tell whether the sound's position is relative to the listener or is absolute. More...
float | getMinDistance () const
| Get the minimum distance of the sound. More...
float | getAttenuation () const
| Get the attenuation factor of the sound. More...

## Protected Attributes
unsigned int | m_source
| OpenAL source identifier. More...

## Detailed Description

Regular sound that can be played in the audio environment.

sf::Sound is the class to use to play sounds.

It provides:

- Control (play, pause, stop)
- Ability to modify output parameters in real-time (pitch, volume, ...)
- 3D spatial features (position, attenuation, ...).

sf::Sound is perfect for playing short sounds that can fit in memory and require no latency, like foot steps or gun shots. For longer sounds, like background musics or long speeches, rather see sf::Music (which is based on streaming).

In order to work, a sound must be given a buffer of audio data to play. Audio data (samples) is stored in sf::SoundBuffer, and attached to a sound with the setBuffer() function. The buffer object attached to a sound must remain alive as long as the sound uses it. Note that multiple sounds can use the same sound buffer at the same time.

Usage example:

sf::SoundBuffer buffer;
buffer.loadFromFile("sound.wav");
sf::Sound sound;
sound.setBuffer(buffer);
sound.play();

See Also
  sf::SoundBuffer, sf::Music

Definition at line 45 of file Sound.hpp.

## Member Enumeration Documentation

enum sf::SoundSource::Status
| inherited

Enumeration of the sound source states.

Enumerator
Stopped | Sound is not playing.
Paused | Sound is paused.
Playing | Sound is playing.

Definition at line 49 of file SoundSource.hpp.

## Constructor & Destructor Documentation

sf::Sound::Sound | ( | ) |  |

Default constructor.

sf::Sound::Sound | ( | const SoundBuffer & | buffer) |  |
| explicit

Construct the sound with a buffer.

Parameters

  buffer | Sound buffer containing the audio data to play with the sound

sf::Sound::Sound | ( | const Sound & | copy) |  |

Copy constructor.

Parameters

  copy | Instance to copy

sf::Sound::~Sound | ( | ) |  |

Destructor.

## Member Function Documentation

float sf::SoundSource::getAttenuation | ( | ) |  | const
| inherited

Get the attenuation factor of the sound.

Returns
  Attenuation factor of the sound

See Also
  setAttenuation, getMinDistance

const SoundBuffer* sf::Sound::getBuffer | ( | ) |  | const

Get the audio buffer attached to the sound.

Returns
  Sound buffer attached to the sound (can be NULL)

bool sf::Sound::getLoop | ( | ) |  | const

Tell whether or not the sound is in loop mode.

Returns
  True if the sound is looping, false otherwise

See Also
  setLoop

float sf::SoundSource::getMinDistance | ( | ) |  | const
| inherited

Get the minimum distance of the sound.

Returns
  Minimum distance of the sound

See Also
  setMinDistance, getAttenuation

float sf::SoundSource::getPitch | ( | ) |  | const
| inherited

Get the pitch of the sound.

Returns
  Pitch of the sound

See Also
  setPitch

Time sf::Sound::getPlayingOffset | ( | ) |  | const

Get the current playing position of the sound.

Returns
  Current playing position, from the beginning of the sound

See Also
  setPlayingOffset

Vector3f sf::SoundSource::getPosition | ( | ) |  | const
| inherited

Get the 3D position of the sound in the audio scene.

Returns
  Position of the sound

See Also
  setPosition

Status sf::Sound::getStatus | ( | ) |  | const

Get the current status of the sound (stopped, paused, playing)

Returns
  Current status of the sound

float sf::SoundSource::getVolume | ( | ) |  | const
| inherited

Get the volume of the sound.

Returns
  Volume of the sound, in the range [0, 100]

See Also
  setVolume

bool sf::SoundSource::isRelativeToListener | ( | ) |  | const
| inherited

Tell whether the sound's position is relative to the listener or is absolute.

Returns
  True if the position is relative, false if it's absolute

See Also
  setRelativeToListener

Sound& sf::Sound::operator= | ( | const Sound & | right) |  |

Overload of assignment operator.

Parameters

  right | Instance to assign

Returns
  Reference to self

void sf::Sound::pause | ( | ) |  |

Pause the sound.

This function pauses the sound if it was playing, otherwise (sound already paused or stopped) it has no effect.

See Also
  play, stop

void sf::Sound::play | ( | ) |  |

Start or resume playing the sound.

This function starts the stream if it was stopped, resumes it if it was paused, and restarts it from beginning if it was it already playing. This function uses its own thread so that it doesn't block the rest of the program while the sound is played.

See Also
  pause, stop

void sf::Sound::resetBuffer | ( | ) |  |

Reset the internal buffer of the sound.

This function is for internal use only, you don't have to use it. It is called by the sf::SoundBuffer that this sound uses, when it is destroyed in order to prevent the sound from using a dead buffer.

void sf::SoundSource::setAttenuation | ( | float | attenuation) |  |
| inherited

Set the attenuation factor of the sound.

The attenuation is a multiplicative factor which makes the sound more or less loud according to its distance from the listener. An attenuation of 0 will produce a non-attenuated sound, i.e. its volume will always be the same whether it is heard from near or from far. On the other hand, an attenuation value such as 100 will make the sound fade out very quickly as it gets further from the listener. The default value of the attenuation is 1.

Parameters

  attenuation | New attenuation factor of the sound

See Also
  getAttenuation, setMinDistance

void sf::Sound::setBuffer | ( | const SoundBuffer & | buffer) |  |

Set the source buffer containing the audio data to play.

It is important to note that the sound buffer is not copied, thus the sf::SoundBuffer instance must remain alive as long as it is attached to the sound.

Parameters

  buffer | Sound buffer to attach to the sound

See Also
  getBuffer

void sf::Sound::setLoop | ( | bool | loop) |  |

Set whether or not the sound should loop after reaching the end.

If set, the sound will restart from beginning after reaching the end and so on, until it is stopped or setLoop(false) is called. The default looping state for sound is false.

Parameters

  loop | True to play in loop, false to play once

See Also
  getLoop

void sf::SoundSource::setMinDistance | ( | float | distance) |  |
| inherited

Set the minimum distance of the sound.

The "minimum distance" of a sound is the maximum distance at which it is heard at its maximum volume. Further than the minimum distance, it will start to fade out according to its attenuation factor. A value of 0 ("inside the head of the listener") is an invalid value and is forbidden. The default value of the minimum distance is 1.

Parameters

  distance | New minimum distance of the sound

See Also
  getMinDistance, setAttenuation

void sf::SoundSource::setPitch | ( | float | pitch) |  |
| inherited

Set the pitch of the sound.

The pitch represents the perceived fundamental frequency of a sound; thus you can make a sound more acute or grave by changing its pitch. A side effect of changing the pitch is to modify the playing speed of the sound as well. The default value for the pitch is 1.

Parameters

  pitch | New pitch to apply to the sound

See Also
  getPitch

void sf::Sound::setPlayingOffset | ( | Time | timeOffset) |  |

Change the current playing position of the sound.

The playing position can be changed when the sound is either paused or playing.

Parameters

  timeOffset | New playing position, from the beginning of the sound

See Also
  getPlayingOffset

void sf::SoundSource::setPosition | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  x | X coordinate of the position of the sound in the scene
  y | Y coordinate of the position of the sound in the scene
  z | Z coordinate of the position of the sound in the scene

See Also
  getPosition

void sf::SoundSource::setPosition | ( | const Vector3f & | position) |  |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  position | Position of the sound in the scene

See Also
  getPosition

void sf::SoundSource::setRelativeToListener | ( | bool | relative) |  |
| inherited

Make the sound's position relative to the listener or absolute.

Making a sound relative to the listener will ensure that it will always be played the same way regardless the position of the listener. This can be useful for non-spatialized sounds, sounds that are produced by the listener, or sounds attached to it. The default value is false (position is absolute).

Parameters

  relative | True to set the position relative, false to set it absolute

See Also
  isRelativeToListener

void sf::SoundSource::setVolume | ( | float | volume) |  |
| inherited

Set the volume of the sound.

The volume is a value between 0 (mute) and 100 (full volume). The default value for the volume is 100.

Parameters

  volume | Volume of the sound

See Also
  getVolume

void sf::Sound::stop | ( | ) |  |

stop playing the sound

This function stops the sound if it was playing or paused, and does nothing if it was already stopped. It also resets the playing position (unlike pause()).

See Also
  play, pause

## Member Data Documentation

unsigned int sf::SoundSource::m_source
| protected inherited

OpenAL source identifier.

Definition at line 263 of file SoundSource.hpp.

The documentation for this class was generated from the following file:

- Sound.hpp